#include <iostream>
#include <algorithm>
#include <vector>
using namespace std;


const int MAX_N = 50;
const int MAX_M = 50;
const int MAX_R = 10;
const int MAX_C = 10;
const int MAX_P = 100;

struct animal {
	unsigned short r, c, k, t;
	unsigned short number;
	int an[MAX_R][MAX_C];
	bool operator<(const struct animal &an) const
	{
		if(abs(k - an.k) < 2)
			return t > an.t;
		return k < an.k;
	}
};

struct jump {
	unsigned short i, j, number;
};

int matrix[MAX_N][MAX_M] = {0};
struct animal animals[MAX_P];
vector< struct jump > jumps;

void print_matrix(int n, int m)
{
	for(int i=0; i<n; i++)
	{
		for(int j=0; j<m; j++)
		{
			printf("%d ", matrix[i][j]);
		}
		printf("\n");
	}
}


int main()
{
	// prenasochva potocite za vhod i izhod
	freopen("parash.in", "r", stdin);
	freopen("parash.out", "w", stdout);
		
	//long points = 0L; //only for testing
	struct jump tmp_jump;
	bool found_bad_cell = false;
	short max_i = -1, max_j = -1, fail_i = -1, fail_j = -1;
	unsigned int max_sum;
	unsigned int sum;
	unsigned short m, n, p;
	unsigned short n_r, m_c; // for fast callculating    n_r = n - r;    m_c = m - c;
	char tmp_str[11];
	char ch;

	scanf("%hu", &n);
	scanf("%hu", &m);
	scanf("%hu", &p);
	
	for(int i = 0; i < n; i++)
	{
		for(int j = 0; j < m; j++)
		{
			scanf("%d", &matrix[i][j]);
		}
	}
	
	for(int _p = 0; _p < p; _p++)
	{
		animals[_p].number = _p + 1;
		scanf("%hu", &animals[_p].r);
		scanf("%hu", &animals[_p].c);
		scanf("%hu", &animals[_p].k);
		scanf("%hu", &animals[_p].t);

		for(int _r = 0; _r < animals[_p].r; _r++)
		{
			scanf("%s", tmp_str);
			for(int _c = 0; _c < animals[_p].c; _c++)
			{
				ch = tmp_str[_c];
				animals[_p].an[_r][_c] = atoi(&ch);
			}
		}
	}

	//sort animals 
	sort(animals, animals + p);
	
	for(int _p = 0; _p < p; _p++)
	{
		// ===== za vseki para6utist =======
		max_sum = 0;
		
		n_r = n - animals[_p].r;
		m_c = m - animals[_p].c;
		for(int i = 0; i <= n_r; i++)
		{

			for(int j = 0; j <= m_c; j++)
			{


				// ====== check every single potential place =========


				if(fail_i != -1 && animals[_p].an[fail_i - i][fail_j - j] == 1)
				{

					
						found_bad_cell = true;
					
					
				}
				else 
					{

						sum = 0;
						for(int _i = 0; _i < animals[_p].r; _i++)
						{

							for(int _j = 0; _j < animals[_p].c; _j++)
							{
						

								// ================ check every single cell ===============


								if(animals[_p].an[_i][_j] == 1)
								{
									if(animals[_p].t <= matrix[_i + i][_j + j])
									{
										sum += matrix[_i + i][_j + j];
										//printf("%d ", matrix[_i + i][_j + j]);
									}
									else 
									{
										//printf("_ ");
										fail_i = _i + i;
										fail_j = _j + j;
										found_bad_cell = true;
										break;
									}
								}
								else
								{
									//printf("%d ", matrix[_i + i][_j + j]);
								}
						

								// =========================================================


							}
							//printf("\n");
							if(found_bad_cell) break;

						}
					}

				
				//printf("\n");
				if(found_bad_cell)
				{
					found_bad_cell = false;
				}
				else
				{
					if(max_sum < sum)
					{
						max_sum = sum;
						max_i = i;
						max_j = j;
					}
				}

				// ==================================================
			}
		}
		//printf("max sum: %d at index %d and %d\n", max_sum, max_i, max_j);
		if(max_sum != 0)
		{
			//points += max_sum; // for testing

			// slagame skoka vuv vectora
			tmp_jump.i = max_i + 1;
			tmp_jump.j = max_j + 1;
			tmp_jump.number = animals[_p].number;
			jumps.push_back(tmp_jump);

			// tuk trqbva da povliqem na poleto na prizemqvane
			for(int i = 0; i < animals[_p].r; i++)
			{
				for(int j = 0; j < animals[_p].c; j++)
				{
					if(animals[_p].an[i][j] == 1)
					{
						matrix[i + max_i][j + max_j] /= animals[_p].k;
					}
				}
			}
		}


		// ==================================================
	}
	
	// print rezult !!!
	int size = jumps.size();
	printf("%d\n", size);
	for(int i = 0; i < size; i++)
	{
		printf("%d %d %d\n", jumps[i].number, jumps[i].i, jumps[i].j);
	}

	// print points for testing
	//printf("points : %ld", points);
	

	//print_matrix(n, m);
	//print_animal(r, c);

	return 0;
}